<?php
    include_once('db.php');
    $db = new DBHelper();
    $auth = new AuthHelper($db);
?>
<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">
        <title></title>
        <link rel="stylesheet" href="style.css">
    </head>
    <body>
        <header>
                <h1>
                    <a href="index.php"><img src="logo.svg" alt="Logo" class="logo" />
                    PiX</a>
                </h1>
                <nav>
                    <a href="index.php">Home</a>
                    <?php if ($auth->isLoggedIn()) { ?>
                        <?= '' // ($auth->user() != NULL) ? $auth->user()->username : '' ?>
                        <a href="logout.php">Logout</a>
                    <?php } else { ?>
                    <input type="radio" id="close" name="popup" checked>
                    <label for="login">Login</label>
                    <input type="radio" id="login" name="popup" />
                    <label class="overlay" for="close"></label>
                    <div class="popup">
                        <h4>Login</h4>
                        <form action="login.php" method="POST">
                            <label class="close" for="close">x</label>
                            <label>Username
                                <input type="text" name="username" id="username" placeholder="Username" required />
                            </label>
                            <label>Password
                                <input type="password" name="password" id="password" placeholder="Password" required />
                            </label>
                            <input class="btn" type="submit" value="Login">
                        </form>
                    </div>
                    <label for="register">Register</label>
                    <input type="radio" id="register" name="popup" />
                    <label class="overlay" for="close"></label>
                    <div class="popup">
                        <h4>Register</h4>
                        <form action="register.php" method="POST">
                            <label class="close" for="close">x</label>
                            <label>Username
                                <input type="text" name="username" id="username" placeholder="Username" required />
                            </label>
                            <label>Password
                                <input type="password" name="password" id="password" placeholder="Password" required />
                            </label>
                            <label>Confirm password
                                <input type="password" name="password2" id="password2" placeholder="Confirm password" required />
                            </label>
                            <input class="btn" type="submit" value="Register">
                        </form>
                    </div>
                    <?php } ?>
                </nav>
        </header>
        <div id="main" class="container">
            <section>
                <h3>Photos</h3>
                <ul>
<?php
    // get all necessary data of all the photos (and a little more)
    $query = 'SELECT photos.id, username AS author, uploaded, path, title, COUNT(comments.id) AS comments 
        FROM photos 
        JOIN users ON photos.author = users.id
        LEFT JOIN comments ON (photos.id = comments.photo) 
        GROUP BY photos.id';
    $query = $db->query($query);
    if (!$query) {
        echo 'An error occured.';
    } else {
        // iterate over all photos and print markup
        while ($fetch = $query->fetch_object()) {
?>
                    <li>
                        <a href="photo.php?pid=<?= $fetch->id ?>">
                            <figure>
                                <img src="images/thumbnails/<?= $fetch->path ?>" alt="<?= $fetch->title ?>" />
                                <figcaption>by <?= $fetch->author ?></figcaption>
                            </figure>
                        </a>
                    </li>
<?php        
        }
    }
?>
                </ul>
            </section>
            <footer class="footer">
                Created by <a href="mailto:weber@openinnovator.net">Thomas Weber</a> as and exercise for 
                the <a href="http://www.mimuc.de/mmn">Online Multimedia</a> lecture during wintersemester 2014/15 
                at <a href="http://www.en.uni-muenchen.de/">LMU Munich</a>.<br />
                Background-image from <a href="http://www.unsplash.com/">unsplash</a>.
            </footer> 
        </div>
    </body>
</html>