<?php
    // forward if no photo is selected
    if (!isset($_GET['pid'])) header('location: index.php');
    
    include_once('db.php');
    $db = new DBHelper();
    $auth = new AuthHelper($db);
    
    $errors = array();
    
    // handling form submission
    if (isset($_POST['comment']) &&
        isset($_POST['uid']) &&
        is_numeric($_POST['uid']) &&
        isset($_POST['pid']) &&
        is_numeric($_POST['pid'])) {
        $cleaned_data = array();
        $valid = true;
        // cleaning data
        $cleaned_data['comment'] = $db->connection()->real_escape_string($_POST['comment']);
        $cleaned_data['uid'] = $db->connection()->real_escape_string($_POST['uid']);
        $cleaned_data['pid'] = $db->connection()->real_escape_string($_POST['pid']);
        // validating user id
        $query = 'SELECT * FROM users WHERE id = '.$cleaned_data['uid'];
        $query = $db->query($query);
        if (!$query) {
            $errors['database'] = 'Error on database connection.';
            $valid = false;
        }
        if ($valid && $query->num_rows < 1) {
            $errors['uid'] = 'User not found.';
            $valid = false;
        }
        // validating photo id
        $query = 'SELECT * FROM photos WHERE id = '.$cleaned_data['pid'];
        $query = $db->query($query);
        if (!$query) {
            $errors['database'] = 'Error on database connection.';
            $valid = false;
        }
        if ($valid && $query->num_rows < 1) {
            $errors['pid'] = 'Photo not found.';
            $valid = false;
        }
        
        if (empty($cleaned_data['comment'])) {
            $valid = false;
            $errors['comment'] = 'This field is required.';
        }
        
        // inserting comment
        if ($valid) {
            $query = 'INSERT INTO comments (user, photo, content, created) 
                VALUES ('.$cleaned_data['uid'].', '.$cleaned_data['pid'].', \''.
                    $cleaned_data['comment'].'\', '.time().')';
            $query = $db->query($query);
            if (!$query) {
                $errors['database'] = 'Error while writing to database.';
            } else {
                // reload on success to clean POST 
                header('location: photo.php?pid='.$cleaned_data['pid']);
            }
        }
    }
?>
<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">
        <title></title>
        <link rel="stylesheet" href="style.css">
    </head>
    <body>
        <header>
                <h1>
                    <a href="index.php"><img src="logo.svg" alt="Logo" class="logo" />
                    PiX</a>
                </h1>
                <nav>
                    <a href="index.php">Home</a>
                    <?php if ($auth->isLoggedIn()) { ?>
                        <?= '' // ($auth->user() != NULL) ? $auth->user()->username : '' ?>
                        <a href="logout.php">Logout</a>
                    <?php } else { ?>
                    <input type="radio" id="close" name="popup" checked>
                    <label for="login">Login</label>
                    <input type="radio" id="login" name="popup" />
                    <label class="overlay" for="close"></label>
                    <div class="popup">
                        <h4>Login</h4>
                        <form action="login.php" method="POST">
                            <label class="close" for="close">x</label>
                            <label>Username
                                <input type="text" name="username" id="username" placeholder="Username" required />
                            </label>
                            <label>Password
                                <input type="password" name="password" id="password" placeholder="Password" required />
                            </label>
                            <input class="btn" type="submit" value="Login">
                        </form>
                    </div>
                    <label for="register">Register</label>
                    <input type="radio" id="register" name="popup" />
                    <label class="overlay" for="close"></label>
                    <div class="popup">
                        <h4>Register</h4>
                        <form action="register.php" method="POST">
                            <label class="close" for="close">x</label>
                            <label>Username
                                <input type="text" name="username" id="username" placeholder="Username" required />
                            </label>
                            <label>Password
                                <input type="password" name="password" id="password" placeholder="Password" required />
                            </label>
                            <label>Confirm password
                                <input type="password" name="password2" id="password2" placeholder="Confirm password" required />
                            </label>
                            <input class="btn" type="submit" value="Register">
                        </form>
                    </div>
                    <?php } ?>
                </nav>
        </header>
        <div id="main" class="container">
            <section>
<?php
    // get photo data from db
    $query = 'SELECT photos.id, username AS author, uploaded, path, title, COUNT(comments.id) AS comments 
        FROM photos 
        JOIN users ON photos.author = users.id
        LEFT JOIN comments ON (photos.id = comments.photo) 
        GROUP BY photos.id HAVING photos.id = '.$_GET['pid'];
    $query = $db->query($query);
    if (!$query) {
        echo '<span class="error">An error occured.</span>';
    } else {
        $fetch = $query->fetch_object();
?>
                <h3><?= $fetch->title ?></h3>
                <h5>by <?= $fetch->author ?></h5>
                <a href="images/<?= $fetch->path ?>"><img class="big" src="images/<?= $fetch->path ?>" alt="<?= $fetch->title ?>" /></a>
                <span class="comment-counter"><?= $fetch->comments ?> comment<?= $fetch->comments != 1 ? 's' : '' ?></span>
                <ul class="comments">
<?php 
        // get comments from db
        $query = 'SELECT username AS author, content, created FROM comments JOIN users ON comments.user = users.id WHERE comments.photo = '.$_GET['pid'].' ORDER BY created ASC';
        $query = $db->query($query);
        if (!$query) {
            echo '<span class="error">An error occured.</span>';
        } else {
            while($fetch = $query->fetch_object()) {
?>
                <li>
                    <span class="author"><?= $fetch->author ?></span>
                    <span class="timestamp"><?= date('d.M o H:i', $fetch->created) ?></span>
                    <?= $fetch->content ?>
                </li>
<?php
            }
        }
?>
                </ul>
<?php
        // form is visible to logged in users only
        if ($auth->isLoggedIn()) { ?>
                <form action="#" method="POST">
                    <!-- error messages -->
                    <?= isset($errors['database']) ? '<span class="error">'.$errors['database'].'</span>' : '' ?>
                    <?= isset($errors['uid']) ? '<span class="error">'.$errors['uid'].'</span>' : '' ?>
                    <?= isset($errors['pid']) ? '<span class="error">'.$errors['pid'].'</span>' : '' ?>
                    <input type="hidden" name="uid" id="uid" value="<?= $auth->user()->id ?>">
                    <input type="hidden" name="pid" id="pid" value="<?= $_GET['pid'] ?>">
                    <label>Your comment
                        <input type="text" name="comment" id="comment" required>
                        <?= isset($errors['comment']) ? '<span class="error">'.$errors['comment'].'</span>' : '' ?>
                    </label>
                    <input type="submit" class="btn" value="Submit">
                </form>
<?php }
} ?>
            </section>
            <footer class="footer">
                Created by <a href="mailto:weber@openinnovator.net">Thomas Weber</a> as and exercise for 
                the <a href="http://www.mimuc.de/mmn">Online Multimedia</a> lecture during wintersemester 2014/15 
                at <a href="http://www.en.uni-muenchen.de/">LMU Munich</a>.<br />
                Background-image from <a href="http://www.unsplash.com/">unsplash</a>.
            </footer> 
        </div>
    </body>
</html>