<?php
    include_once('db.php');
    $db = new DBHelper();
    $auth = new AuthHelper($db);
    
    if ($auth->isLoggedIn()) header('location: index.php');
    // handle form submission
    if (isset($_POST['username']) &&
        isset($_POST['password']) &&
        isset($_POST['password2'])) {
        if ($auth->register($_POST)) {
            // if registration is successful, log user in and redirect to frontpage
            $auth->login($_POST);
            header('Location: index.php');
        }
    }
    $errors = $auth->errors();
    
?>
<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">
        <title></title>
        <link rel="stylesheet" href="style.css">
    </head>
    <body>
        <header>
                <h1>
                    <a href="index.php"><img src="logo.svg" alt="Logo" class="logo" />
                    PiX</a>
                </h1>
                <nav>
                    <a href="index.php">Home</a>
                    <input type="radio" id="close" name="popup" checked>
                    <label for="login">Login</label>
                    <input type="radio" id="login" name="popup">
                    <label class="overlay" for="close"></label>
                    <div class="popup">
                        <h4>Login</h4>
                        <form action="login.php" method="POST">
                            <label class="close" for="close">x</label>
                            <label>Username
                                <input type="text" name="username" id="username" placeholder="Username" required />
                            </label>
                            <label>Password
                                <input type="password" name="password" id="password" placeholder="Password" required />
                            </label>
                            <input class="btn" type="submit" value="Login">
                        </form>
                    </div>
                </nav>
        </header>
        <div id="main" class="container">
            <h3>Register</h3>
            <form action="register.php" method="POST">
                <?= isset($errors['database']) ? '<span class="error">'.$errors['database'].'</span>' : '' ?>
                <span class="error"><?= $db->connection()->error ?></span>
                <label>Username
                    <input type="text" name="username" id="username" placeholder="Username" <?= isset($_POST['username']) ? 'value="'.$_POST['username'].'" ' : '' ?>required />
                    <?= isset($errors['username']) ? '<span class="error">'.$errors['username'].'</span>' : '' ?>
                </label>
                <label>Password
                    <input type="password" name="password" id="password" placeholder="Password" required />
                    <?= isset($errors['password']) ? '<span class="error">'.$errors['password'].'</span>' : '' ?>
                </label>
                <label>Confirm password
                    <input type="password" name="password2" id="password2" placeholder="Confirm password" required />
                    <?= isset($errors['password2']) ? '<span class="error">'.$errors['password2'].'</span>' : '' ?>
                </label>
                <input class="btn" type="submit" value="Register">
            </form>
            <footer class="footer">
                Created by <a href="mailto:weber@openinnovator.net">Thomas Weber</a> as and exercise for 
                the <a href="http://www.mimuc.de/mmn">Online Multimedia</a> lecture during wintersemester 2014/15 
                at <a href="http://www.en.uni-muenchen.de/">LMU Munich</a>.<br />
                Background-image from <a href="http://www.unsplash.com/">unsplash</a>.
            </footer> 
        </div>
    </body>
</html>
        